'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RouterUtil = require('./RouterUtil');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {
	return undefined;
};

/**
 * @class 
 * @author gcy[of1518]
 * @date 2017.06
 * @description 对import返回的Promise对象进行处理，
 */

var LazilyLoader = function (_Component) {
	_inherits(LazilyLoader, _Component);

	function LazilyLoader(props) {
		var _this2 = this;

		_classCallCheck(this, LazilyLoader);

		var _this = _possibleConstructorReturn(this, (LazilyLoader.__proto__ || Object.getPrototypeOf(LazilyLoader)).call(this, props));

		_this.syncLoadBundle = function () {
			var self = _this;

			var _ref = _this.state || {},
			    Component = _ref.Component;

			var _this$props = _this.props,
			    name = _this$props.name,
			    source = _this$props.source;

			try {
				if (window['@bundle-' + name]) {
					//从缓存里获取
					self.setState({ Component: window['@bundle-' + name] || null });
					return;
				}
				if (!_this._isMounted) return null;
				Object.keys(source).forEach(function (k) {
					var v = source[k];
					if (v.includes('.css')) {
						(0, _RouterUtil.appendLink)({ name: name + '-' + k, href: v });
					} else if (v.includes('.js')) {
						var comp = (0, _RouterUtil.appendBundles)({
							name: name + '-' + k, src: v,
							onload: function onload() {
								self.setState({ Component: window['@bundle-' + name] || null });
							},
							onerror: function onerror() {
								console.error('syncLoadBundle:--->' + name + '|' + v + '\u52A0\u8F7D\u5931\u8D25\uFF01');
							}
						});
					}
				});
			} catch (e) {
				console.error(e || 'bundle加载错误!');
				if (__DEV__) {
					throw e;
				}
			}
		};

		_this.syncLoadChunk = function () {
			var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref3) {
				var name = _ref3.name;

				var self, _ref4, Component, _this$props2, render, source, comp;

				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								self = _this;
								_ref4 = _this.state || {}, Component = _ref4.Component;
								_this$props2 = _this.props, render = _this$props2.render, source = _this$props2.source;
								_context.prev = 3;

								if (_this._isMounted) {
									_context.next = 6;
									break;
								}

								return _context.abrupt('return', null);

							case 6:
								_context.next = 8;
								return render();

							case 8:
								comp = _context.sent;

								_this.setState({ Component: comp.default || null });
								_context.next = 15;
								break;

							case 12:
								_context.prev = 12;
								_context.t0 = _context['catch'](3);

								console.error(_context.t0 || 'chunk加载错误!');

							case 15:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this2, [[3, 12]]);
			}));

			return function (_x) {
				return _ref2.apply(this, arguments);
			};
		}();

		_this.state = {
			Component: null
		};
		return _this;
	}

	_createClass(LazilyLoader, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this._isMounted = true;

			var _ref5 = this.props || {},
			    isBundle = _ref5.isBundle,
			    isChunk = _ref5.isChunk;

			if (isBundle) {
				this.syncLoadBundle(this.props);
			} else if (isChunk) {
				this.syncLoadChunk(this.props);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _ref6 = this.state || {},
			    Component = _ref6.Component;

			var _ref7 = this.props || {},
			    children = _ref7.children;

			return !!Component ? _react2.default.createElement(
				Component,
				this.props,
				children
			) : null;
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this._isMounted = false;
		}

		/**
   * @method
   * @param {Array}
   * @description 加载Bundle（业务线main.js入口）
   */


		/**
   * @method
   * @param {Array}
   * @description 加载Chunk（页面分片chunkFile.js入口）
   */

	}]);

	return LazilyLoader;
}(_react.Component);

exports.default = LazilyLoader;