'use strict';

/**
 * @method appendScripts
 * @author gcy[of1518]
 * @date 2017.06
 * @param {string} name 文件key值
 * @param {string} src 文件路径
 * @desc 加载额外js脚本
 */

Object.defineProperty(exports, "__esModule", {
	value: true
});
var appendScripts = function appendScripts(_ref) {
	var name = _ref.name,
	    src = _ref.src,
	    key = _ref.key;

	name = key + '_js_' + (name || 'def');
	if (document.getElementById(name) && window[key]) {
		return;
	} else {
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.charset = 'utf-8';
		script.id = name;
		script.timeout = 30000;
		script.src = src || 'javascript:void(0);';
		var timeout = setTimeout(onScriptComplete, 30000);
		script.onerror = script.onload = onScriptComplete;
		var onScriptComplete = function onScriptComplete() {
			script.onerror = script.onload = null;
			clearTimeout(timeout);
			var chunk = installedChunks[chunkId];
			if (chunk !== 0) {
				if (chunk) {
					chunk[1](new Error('Loading chunk ' + chunkId + ' failed.'));
				}
				installedChunks[chunkId] = undefined;
			}
		};
		document.body.appendChild(script);
	}
};

/**
 * @method appendBundles
 * @author gcy[of1518]
 * @date 2017.06
 * @param {string} name 文件key值
 * @param {string} src 文件路径
 * @return {Promise} 返回promise对象
 * @desc 控制台入口main.js
 */
var appendBundles = function appendBundles(_ref2) {
	var name = _ref2.name,
	    src = _ref2.src,
	    onload = _ref2.onload,
	    onerror = _ref2.onerror;

	if (document.getElementById(name) && window[name]) {
		onload();
		return;
	} else {
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.charset = 'utf-8';
		script.id = name;
		script.timeout = 30000;
		script.src = src || 'javascript:void(0);';
		script.onerror = onerror;
		script.onload = onload;
		document.body.appendChild(script);
	}
};

/**
 * @method appendLink
 * @author gcy[of1518]
 * @date 2017.06
 * @param {string} name
 * @param {string} href
 * @desc 加载额外样式
 */
var appendLink = function appendLink(_ref3) {
	var name = _ref3.name,
	    href = _ref3.href;

	if (document.getElementById(name)) {
		console.info(name + '\u5DF2\u7ECF\u5B58\u5728');
		return;
	} else {
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.id = name;
		link.href = href || '';
		document.head.appendChild(link);
	}
};

exports.appendScripts = appendScripts;
exports.appendBundles = appendBundles;
exports.appendLink = appendLink;